/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

ƌfpvOi͂_Ƃ̎lʑ̕\j

_̒_ɑ΂Ďlʑ̕s

eɂĂ̓vOQCRQƂĂ

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

#include <LEDA/window.h>
#include <LEDA/d3_window.h>
#include <LEDA/random_rat_point.h>
#include <stdio.h>
#include <LEDA/d3_delaunay.h>
#include <LEDA/d3_point.h>
#include <LEDA/d3_segment.h>
#include <LEDA/d3_rat_segment.h>
#include <LEDA/graph.h>
#include <LEDA/templates/shortest_path.t>

using namespace leda;
using std::cin;
using std::cout;
using std::endl;
using leda::string;

void rmove_triangle(GRAPH<d3_rat_point,int>& );

void knot_segment_find(GRAPH<d3_rat_point,int>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& );

void search_knot_node(GRAPH<d3_rat_point,int>& ,list<d3_rat_point>& ,list<node>& );

void knots_short_path(GRAPH<d3_rat_point,int>& ,list<node>& ,list<d3_rat_point>& ,list<d3_rat_point>& );

void creat_knot(GRAPH<d3_rat_point,int>& ,list<d3_rat_point>& );

void input_point(GRAPH<d3_rat_point,int>& ,list<d3_rat_point>& ,list<d3_rat_point>&  ,list<d3_rat_point>& ,list<d3_rat_point>& );

void input_zcoord(list<point>& ,list<int>& );


int compare_knot(list<d3_rat_point>& ,d3_rat_point ,d3_rat_point ,d3_rat_point ,d3_rat_point );

void append_point(list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,d3_rat_point ,d3_rat_point ,d3_rat_point ,d3_rat_point );

void rmove_knot(list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& );

void remake_DELAUNAY(GRAPH<d3_rat_point,int>& ,GRAPH<d3_rat_point,int> & );

int how_node(GRAPH<d3_rat_point,int>& ,GRAPH<d3_rat_point,int>& ,node,node);

void add_two_node_graph(GRAPH<d3_rat_point,int>& ,GRAPH<d3_rat_point,int>& ,node,node);

void search_adj_node(GRAPH<d3_rat_point,int>& ,GRAPH<d3_rat_point,int>& ,node,node);

void add_one_node_graph(GRAPH<d3_rat_point,int>& ,GRAPH<d3_rat_point,int>& ,node,node);

void ganp_tetora(list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& );

void push_the_list(list<d3_rat_point>& ,list<d3_rat_point>& );

void search_conect_knot(list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& );

void create_graph(GRAPH<d3_rat_point,int>& , list<d3_rat_point>& , list<d3_rat_point>& , list<d3_rat_point>& , list<d3_rat_point>& );

void d3_window_system(GRAPH<d3_rat_point,int>& , node_array<rat_vector>& ,color ,int );

window W(800,800,"UWF INTER SONE");

int main(){
  node v;
  list<d3_rat_point> DTL,DTL_inside,midle2_LK,RES_LK,LK;
  

  GRAPH<d3_rat_point,int> DTG,remake_DTG,knot;

  // __ɐ
  random_d3_rat_points_in_ball(30,120,DTL);
  random_d3_rat_points_in_ball(5,45,DTL_inside);

  /*_Ƃ\鏀*/
  input_point(knot,DTL,DTL_inside,LK,midle2_LK);
  
  D3_DELAUNAY(DTL,DTG);

  rmove_triangle(DTG);

  remake_DELAUNAY(remake_DTG,DTG);
 

 
 W.set_bg_color(black);
 W.init(-110,110,-110);
 W.display(0,0);
 
  /////////////////////////

 node_array<rat_vector> posk(knot);
 forall_nodes(v,knot) posk[v]=knot[v].to_vector();

 node_array<rat_vector> pos1(remake_DTG);
 forall_nodes(v,remake_DTG) pos1[v]=remake_DTG[v].to_vector();


 
 d3_window_system(knot,posk,yellow,6);

 W.clear();

 d3_window_system(remake_DTG,pos1,yellow,6);

 W.read_mouse();	
 return 0;
}
///////////////////////////////////////////////////////////////////////




void d2_push_segment(list<point>& LK,list<segment>& SEG){

  point dp1,dp2;
  segment s,s2;
  int i=0;
  int L_size;

  L_size=LK.size();

  while(i<L_size){

    if((i+1)==L_size){
      dp1=LK[LK.get_item(i)];
      dp2=LK[LK.get_item(0)];
      segment ds(dp1,dp2);
      SEG.append(ds);

    }

    else{
      dp1=LK[LK.get_item(i)];
      dp2=LK[LK.get_item(i+1)];
      segment ds(dp1,dp2);
      SEG.append(ds);
    }
    i++;
  }
}
/////////////////////////////////////////////

void remake_DELAUNAY(GRAPH<d3_rat_point,int>& G,GRAPH<d3_rat_point,int> & T){

  edge e;

  forall_edges(e,T){

    node s=T.source(e);
    node t=T.target(e);

    switch(how_node(G,T,s,t)){

    case 0: add_two_node_graph(G,T,s,t);
            break;

    case 2: search_adj_node(G,T,s,t);
            break;

    case 3: add_one_node_graph(G,T,s,t);
            break;

    case 4: add_one_node_graph(G,T,t,s);
            break;
    }
  }
}


int how_node(GRAPH<d3_rat_point,int>& G,GRAPH<d3_rat_point,int>& T,node s,node t){

  int answer=0,which_answer=0;
  node n;

  forall_nodes(n,G){

    if(G[n]==T[s]){

      answer++;
      which_answer=3;

    }

    if(G[n]==T[t]){

      answer++;
      which_answer=4;
    }
  }

  if(answer==1){ return which_answer; }
  
  else{ return answer; }
}

void add_two_node_graph(GRAPH<d3_rat_point,int>& G,GRAPH<d3_rat_point,int>& T,node s,node t){

  node v1=G.new_node();
  G[v1]=T[s];

  node v2=G.new_node();
  G[v2]=T[t];

  G.new_edge(v1,v2);
  G.new_edge(v2,v1);
}

void search_adj_node(GRAPH<d3_rat_point,int>& G,GRAPH<d3_rat_point,int>& T,node s,node t){

  list<node> L_NODE;
  node n,nt,n1,n2;

  forall_nodes(n,G){
    if(G[n]==T[s]){
      break;
    }
  }
  forall_nodes(nt,G){
    if(G[nt]==T[t]){
      break;
    }
  }

  L_NODE=G.adj_nodes(n);

  if(L_NODE.search(nt)==nil){

    forall_nodes(n1,G){

      if(G[n1]==T[s]){

	forall_nodes(n2,G){

	  if(G[n2]==T[t]){

	    G.new_edge(n1,n2);
	    G.new_edge(n2,n1);
	  }
	}
      }
    }
  }
}


void add_one_node_graph(GRAPH<d3_rat_point,int>& G,GRAPH<d3_rat_point,int>& T,node x,node y){

  node n;

  node v2=G.new_node();
  G[v2]=T[y];

  forall_nodes(n,G){

    if(G[n]==T[x]){


      G.new_edge(n,v2);
      G.new_edge(v2,n);

      break;
    }
  }
}



/////////////////////////////////////////////////////////////////////////
void rmove_triangle(GRAPH<d3_rat_point,int>& G){

  node v;
  list<node> rm_L;

  forall_nodes(v,G){

    if(G.degree(v)==4){
      rm_L.append(v);
    }
  }

  forall(v,rm_L){

    node rmv=v;
    G.del_node(rmv);
  }
}


void creat_knot(GRAPH<d3_rat_point,int>& knot,list<d3_rat_point>& LK){

  d3_rat_point p;
  list<node> N;
  node v,x1,x2;
  int L_size,i=0;

  forall(p,LK){
    node v1=knot.new_node();
    knot[v1]=p;
  }

  // N.sort();

  forall_nodes(v,knot){
    N.append(v);
  }
  

  L_size=N.size();

  while(i<L_size){

    if((i+1)==L_size){
      x1=N[N.get_item(i)];
      x2=N[N.get_item(0)];

      knot.new_edge(x1,x2);
      knot.new_edge(x2,x1);
    }
    
    else{

      x1=N[N.get_item(i)];
      x2=N[N.get_item(i+1)];

      knot.new_edge(x1,x2);
      knot.new_edge(x2,x1);
    }
    i++;
  }
}

void input_point(GRAPH<d3_rat_point,int>& knot2,list<d3_rat_point>& L,list<d3_rat_point>& L2,list<d3_rat_point>& LK,list<d3_rat_point>& midle2_LK){

  d3_rat_point p;

 
  forall(p,L){
    node v1=knot2.new_node();
    knot2[v1]=p;
  }

  forall(p,L2){
    node v1=knot2.new_node();
    knot2[v1]=p;
  }
  /*
  forall(p,LK){
    L.append(p);
  }
  */

  forall(p,midle2_LK){
    L.append(p);
  }

  forall(p,L2){
    L.append(p);
  }
}



void d3_window_system(GRAPH<d3_rat_point,int>& G, node_array<rat_vector>& pos,color C,int width){

  d3_window d3win2(W,G,pos);
  d3win2.set_draw_graph(true);
  d3win2.set_speed(16);
  d3win2.set_message
    ("\\bf\\white left:  \\green zoom up   ~~~~~\
     \\bf\\white middle:\\green zoom down ~~~~~\
     \\bf\\white right: \\green exit");
  d3win2.set_node_color(C);
  d3win2.set_edge_color(white);
  d3win2.set_node_width(width);
  d3win2.draw();     
  int but = 0;   
  while (but != MOUSE_BUTTON(3)) but = d3win2.move();
  
}
